switch-priv-modes:
  switch_modes: true 
  num_switches: 40

priv-mode:
  mode: m

general:
  total_instructions: 500
  regs_not_use: x1,x2,x0
  custom_trap_handler: false
  code_start_address: 0x80000000
  default_program_exit: false
  delegation: 0x000

isa-instruction-distribution:
  rel_sys: 0
  rel_sys.csr: 0
  rel_rv32i.ctrl: 50
  rel_rv32i.compute: 10
  rel_rv32i.data: 90
  rel_rv32i.fence: 40
  rel_rv64i.compute: 10
  rel_rv64i.data: 90
  rel_rv32m: 10
  rel_rv64m: 10
  rel_rv32a: 10
  rel_rv64a: 10
  rel_rv32f: 10
  rel_rv64f: 10
  rel_rv32d: 30
  rel_rv64d: 10
  rel_rvc.ctrl: 5
  rel_rvc.compute: 10
  rel_rvc.sp: 10
  rel_rvc.data: 90
  rel_rvc.fdata: 90
  rel_rv32c.compute: 10
  rel_rv32c.ctrl: 10
  rel_rv32c.fdata: 90
  rel_rv64c.compute: 10
  rel_rv64c.data: 90

float-rounding:
  rne: 10
  rtz: 10
  rdn: 10
  rup: 10
  rmm: 10
  dyn: 10

branch-control:
  block-size: 7
  backward-probability: 0.5

recursion-options:
  recursion-enable: false
  recursion-depth: 10
  recursion-calls: 5

#Normally: begin_signature: 0x80090000,0x800a0000,rw

access-sections:
  begin_signature: 0x80090000,0x800a0000,rw

#Line stride
#Testing half blocks twice each from a set of blocks, then calling sequentially over the set of blocks- done at page ends so as to get byte accesses in two different pages.
#The above is done for 5 pages by storing addreses in 5 regs, then page striding all of them.
user-functions:
  func1: '{50: "addi sp, sp, -15*REGBYTES;SREG t0, 5*REGBYTES(sp);SREG t2, 7*REGBYTES(sp);SREG s1, 9*REGBYTES(sp);SREG s3, 19*REGBYTES(sp);SREG t6, 31*REGBYTES(sp);SREG a1, 11*REGBYTES(sp);SREG s7, 23*REGBYTES(sp);SREG a0, 10*REGBYTES(sp);SREG t1, 6*REGBYTES(sp);li t2, 0xabee;li s7, 0xab;la t0, begin_signature;li s5,0;addi s5,s5,2047;addi s5,s5,1;slli s5,s5,1; add t0, t0, s5      ;slli s5,s5,1;add t1,t0,s5;add t3,t1,s5;add t4,t3,s5;srli s5,s5,1;li a1, 0x5;li a0, 0x8;li s3,0;loop_outer:li s1,0;loop_pg_end:lb t2, -128(t3);  lb t2, -128(t3); lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -128(t3); div t2,t1,t0;  lb t2, -128(t3);lb t2, -128(t3);  lb t2, -128(t3);lb t2, -96(t3);  lb t2, -96(t3); lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3);lb t2, -96(t3);  lb t2, -96(t3); lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -64(t3);  lb t2, -32(t3); div t2,t1,t0;  lb t2, -32(t3);lb t2, -32(t3);  lb t2, -32(t3);lb t2, -32(t3);  lb t2, -32(t3);  lb t2, 0(t3);lb t2, 0(t3);lb t2, 0(t3);lb t2, 0(t3);  lb t2, 0(t3);  lb t2, 32(t3);  lb t2, 32(t3); lb t2, 32(t3); lb t2, 32(t3); lb t2, 32(t3); lb t2, 32(t3);  lb t2, 64(t3); lb t2, 64(t3); lb t2, 64(t3); lb t2, 64(t3); lb t2, 64(t3);  lb t2, 64(t3);  lb t2, 128(t3);  lb t2, 128(t3);lb t2, 128(t3);lb t2, 128(t3); lb t2, 128(t3);lb t2, 128(t3); lb t2, -192(t3);  lb t2, -128(t3);  lb t2, -64(t3);  lb t2, 0(t3);  lb t2, 64(t3);  lb t2, 128(t3);  lb t2, 192(t3);  lb t2, 256(t3);  lb t2, -128(t0);  lb t2, -128(t0);  lb t2, -96(t0);  lb t2, -96(t0);  lb t2, -64(t0);  add t2,t0,t3; div t2,t1,t0; lb t2, -64(t0);  lb t2, -32(t0);  lb t2, -32(t0);  lb t2, 0(t0);  lb t2, 0(t0);  lb t2, 32(t0);  lb t2, 32(t0);  lb t2, 64(t0);  lb t2, 64(t0);  lb t2, 128(t0);  lb t2, 128(t0);  lb t2, -192(t0);  lb t2, -128(t0);  lb t2, -64(t0);  lb t2, 0(t0);  lb t2, 64(t0);  lb t2, 128(t0);  lb t2, 192(t0);  lb t2, 256(t0);  lb t2, -128(t4); lb t2, -128(t4); lb t2, -128(t4); lb t2, -128(t4); lb t2, -128(t4);  lb t2, -128(t4);  lb t2, -96(t4);  lb t2, -96(t4);lb t2, -96(t4);lb t2, -96(t4);  lb t2, -64(t4);lb t2, -64(t4);lb t2, -64(t4);  lb t2, -64(t4);  lb t2, -32(t4);  lb t2, -32(t4);  lb t2, 0(t4);  lb t2, 0(t4);lb t2, 0(t4);lb t2, 0(t4);  lb t2, 32(t4);lb t2, 32(t4);lb t2, 32(t4);  lb t2, 32(t4);  lb t2, 64(t4);  lb t2, 64(t4);lb t2, 64(t4);  lb t2, 64(t4);  lb t2, 128(t4);  lb t2, 128(t4);lb t2, 128(t4);lb t2, 128(t4);  lb t2, -192(t4);  lb t2, -128(t4);  lb t2, -64(t4);  lb t2, 0(t4);  lb t2, 64(t4);  lb t2, 128(t4);  lb t2, 192(t4);  lb t2, 256(t4);  lb t2, -128(t1);  lb t2, -128(t1);lb t2, -128(t1);  lb t2, -128(t1);  lb t2, -96(t1);  lb t2, -96(t1);lb t2, -96(t1);  lb t2, -96(t1);lb t2, -96(t1);  lb t2, -96(t1);lb t2, -96(t1);  lb t2, -96(t1);  lb t2, -64(t1);div t2,t1,t0;   lb t2, -64(t1);lb t2, -64(t1);div t2,t1,t0;   lb t2, -64(t1);lb t2, -64(t1);div t2,t1,t0;   lb t2, -64(t1);  lb t2, -32(t1);  lb t2, -32(t1);  lb t2, -32(t1); lb t2, -32(t1); lb t2, 0(t1);  lb t2, 0(t1);  lb t2, 32(t1);  lb t2, 32(t1);  lb t2, 32(t1);  lb t2, 32(t1);  lb t2, 64(t1);  lb t2, 64(t1);lb t2, 64(t1);  lb t2, 64(t1);  lb t2, 128(t1);  lb t2, 128(t1); lb t2, 128(t1); lb t2, 128(t1); lb t2, 128(t1);  lb t2, -192(t1);  lb t2, -128(t1);  lb t2, -64(t1);  lb t2, 0(t1);  lb t2, 64(t1);  lb t2, 128(t1);  lb t2, 192(t1);  lb t2, 256(t1);add t0,t0,s5;add t1,t1,s5;add t3,t3,s5;add t4,t4,s5;addi s1,s1,1;bne a0, s1 ,  loop_pg_end;addi s3,s3,1;bne a1, s3,loop_outer;LREG t0, 5*REGBYTES(sp);LREG t2, 7*REGBYTES(sp);LREG s1, 9*REGBYTES(sp);LREG s3, 19*REGBYTES(sp);LREG t6, 31*REGBYTES(sp);LREG a1, 11*REGBYTES(sp);LREG s7, 23*REGBYTES(sp);LREG a0, 10*REGBYTES(sp);LREG t1, 6*REGBYTES(sp); addi sp, sp, 15*REGBYTES" }'


#Literally just stressing one byte too many times:
  func2: '{50: "addi sp, sp, -15*REGBYTES;SREG t0, 5*REGBYTES(sp);SREG t2, 7*REGBYTES(sp);SREG s1, 9*REGBYTES(sp);SREG s3, 19*REGBYTES(sp);SREG t6, 31*REGBYTES(sp);SREG a1, 11*REGBYTES(sp);SREG s7, 23*REGBYTES(sp);SREG a0, 10*REGBYTES(sp);SREG t1, 6*REGBYTES(sp);li t2, 0xabee;li s7, 0xab;la t4, begin_signature;li a1, 0x10;li a0, 0x8;li s3,0;loop_outer2:li s1,0;loop_pg_end2:lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4); div t2,s7,t2;   lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);div t2,s7,t2; lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);div t2,s7,t2;  lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);lb t2, 64(t4);addi s1,s1,1;bne a0, s1 , loop_pg_end2;addi s3,s3,1;bne a1, s3,loop_outer2;LREG t0, 5*REGBYTES(sp);LREG t2, 7*REGBYTES(sp);LREG s1, 9*REGBYTES(sp);LREG s3, 19*REGBYTES(sp);LREG t6, 31*REGBYTES(sp);LREG a1, 11*REGBYTES(sp);LREG s7, 23*REGBYTES(sp);LREG a0, 10*REGBYTES(sp);LREG t1, 6*REGBYTES(sp); addi sp, sp, 15*REGBYTES" }'


i-cache:
  num_calls: 0
  num_bytes_per_block: 64
  num_blocks: 512
  num_cycles: 100

d-cache:
  num_calls: 0
  num_bytes_per_block: 64
  num_blocks: 512
  num_cycles: 100

exception-generation:
  ecause00: 0
  ecause01: 0
  ecause02: 0
  ecause03: 0
  ecause04: 0
  ecause05: 0
  ecause06: 0
  ecause07: 0
  ecause08: 0
  ecause09: 0
  ecause10: 0
  ecause11: 0
  ecause12: 0
  ecause13: 0
  ecause14: 0

csr-sections:
  sections: 0x000:0xfff

data-hazards:
  raw_prob: 1
  war_prob: 1
  waw_prob: 1
  num_regs_lookbehind: 3

program-macro:
  pre_program_macro: "add x0,x0,x0"
  post_program_macro: "li gp,1; \n sw gp, tohost, t5;\n fence.i;\n li t6,  0x20000; \n la t5, begin_signature; \n sw t5, 0(t6); \n la t5, end_signature \n sw t5, 8(t6); \n sw t5,  12(t6);"        
  pre_branch_macro: "add x0,x0,x0"
  post_branch_macro: "add x0,x0,x0"
  ecause00: "random"
  ecause01: "random"
  ecause02: "random"
  ecause03: "random"
  ecause04: "random"
  ecause05: "random"
  ecause06: "random"
  ecause07: "random"
  ecause08: "random"
  ecause09: "random"
  ecause10: "random"
  ecause11: "random"
  ecause12: "random"
  ecause13: "random"
  ecause14: "random"
